#include <SFML/Graphics.hpp>
#include <iostream>
#include <math.h>
#include <vector>
#include <sstream>

class Player: public sf::Drawable
{
	private:
		bool accelerating;
		bool decelerating;
		float rotation;
		float frame;
		int currentFrame;
		bool inWater;
		float rotations;
		int direction, previousDirection;
		sf::Vector2f velocity;
	protected:
		sf::Sprite sprite;
		sf::Vector2f position;
		sf::Texture texture;
	public:
		Player(sf::Vector2f position, sf::Texture& texture);
		sf::Vector2f getPosition();
		void setPosition(sf::Vector2f position);
		float getSpeed();
		float getRotations();
		void move(sf::Vector2f movement);
		void rotate(int direction, sf::Time time);
		bool isInControl();
		bool isUnderwater();
		float movementDirection();
		void increaseSpeed();
		void decreaseSpeed();
		void left(sf::Time time);
		void right(sf::Time time);
		void forward();
		void tick(sf::Time timeSinceLastTick, std::vector<std::pair<std::string, sf::Time>>& messages, std::vector<std::pair<std::string, sf::Time>>& messages2, int& score);

		void draw(sf::RenderTarget &target, sf::RenderStates states)const;
};
